////////////////////////////////////////////////////////////////////////////////
//
//	Author: Leblanc Christophe < christopheleblanc@gmx.com >
//	
//	-This code is distributed for free without any warrantee.
//      -You can use it and redistribute it without restrictions.
//	
////////////////////////////////////////////////////////////////////////////////

//This is a part of "MATH"
function rotateCoords(pX, pY, angle){
    
        var point = [0, 0];

        var s = Math.sin(angle);
        var c = Math.cos(angle);

        // rotate point
        point[0] = pX * c - pY * s;
        point[1] = pX * s + pY * c;


        return point;
        
}

var PolyCoords = {};

PolyCoords.Coord = function(x, y, angle, rad){
    this.x = x;
    this.y = y;
    this.angle = angle;
    this.rad = rad;
}

PolyCoords.Gen = {};

PolyCoords.Gen.circle = function(x, y, nPoints, radiusA, startAngle, maxAngle, closed){
        
    var coords = [];

    if(nPoints > 0){

        startAngle = (startAngle === undefined) ? 0 : startAngle;
        maxAngle = (maxAngle === undefined) ? 360 : maxAngle;
        closed = (closed === undefined) ? false : closed;
        
        //Prohibit the "closing" point if th arc max angle is greater than 360 degrees
        if(maxAngle >= 360 && closed){
            closed = false;
        }
        
        var step = maxAngle / nPoints;

        var length = (closed) ? nPoints + 1 : nPoints;

        for(var i = 0; i < length; i++){

             //Calculate angle (deg)
            var angle = (step * i) + startAngle;

            var rad = Phaser.Math.DegToRad(angle);

            var pt = rotateCoords(radiusA, 0, rad);

            //Add Position offset
            pt[0] += x;
            pt[1] += y;

            coords.push(new PolyCoords.Coord(pt[0], pt[1], angle, rad));

        }

    }

    return coords;
        
}


PolyCoords.createStarCirclefromPoints = function(x, y, nPoints, radiusA, radiusB, startAngle){
        
        var coords = [];
        
        if(nPoints > 0){
            
            var step = 360.0 / nPoints;
        
            var pXa = radiusA;
            var pXB = radiusB;

            startAngle = (startAngle === undefined) ? 0 : startAngle;

            var bit = 0;

            for(var i = 0; i < nPoints; i++){

                 //Calculate angle (deg)
                var angle = (step * i) + startAngle;

                var rad = Phaser.Math.DegToRad(angle);

                var pt = rotateCoords(pXa, 0, rad);

                //Add Position offset
                pt[0] += x;
                pt[1] += y;

                coords.push(new PolyCoords.Coord(pt[0], pt[1], angle, rad));

            }
            
        }
        
        return coords;
        
}
