/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

var VisualEffects = {};

VisualEffects.VisualEffect = function(){
    
    var th_ = this;
    
    var parent = this;
    
    this.startPos;
    
    this.delay = 0;
    this.lifeSpan = 1000;
    
    this.life;
    this.delayed;
    this.delayLife;
    
    this.tweens = [];
    
    this.initCall = function(){};
    this.createCall = function(){};
    this.updateCall = function(delta){};
    
    this.create = function(){
        
        if(th_.delay == 0){
            th_.createCall();
            th_.delayed = false;
            
        }
        else{
            th_.delayLife = th_.delay;
            th_.delayed = true;
        }
        
    }
    
    
    
    this.init = function(){
        
        th_.life = th_.lifeSpan;
        
        th_.initCall();
        
    }
    
    this.update = function(delta){
        
        if(th_.delayed){
            
            if(th_.delayLife <= 0){
                
                th_.createCall();
                th_.delayed = false;
                
            }
            else{
                th_.delayLife -= delta;
            }
            
        }
        else{
            
            th_.updateCall(delta);

            th_.life -= delta;
            
        }
        
    }
    
    this.pause = function(){
        
        //Tweens
        for(var i = 0; i < th_.tweens.length; i++){
            th_.tweens[i].pause();
        }
        
    }
    
    this.resume = function(){
        
        //Tweens
        for(var i = 0; i < th_.tweens.length; i++){
            th_.tweens[i].resume();
        }
        
    }
    
    this.setPause = function(pause){
        
        if(pause){
            th_.pause();
        }
        else{
            th_.resume();
        }
        
    }
    
    this.play = function(phaser, x, y){
        
        th_.phaser = phaser;
        th_.startPos = new Phaser.Math.Vector2(x, y);
        
        th_.init();
        
        th_.create();
        
    }
    
    
}
VisualEffects.VisualEffect.prototype.destroy = function(){
        
    this.destroyCall();

    for(var i = 0; i < this.tweens.length; i++){
        this.tweens[i].stop();
    }
    
    
}

VisualEffects.Particles = function(){
    VisualEffects.VisualEffect.call(this);
    
    
}
VisualEffects.Particles.prototype = Object.create(VisualEffects.VisualEffect.prototype);
VisualEffects.Particles.prototype.constructor = VisualEffects.Particles;
VisualEffects.Particles.prototype.destroy = function(){
    VisualEffects.VisualEffect.prototype.destroy.call(this);
    
}

VisualEffects.Fx1 = function(){
    VisualEffects.Particles.call(this);
    
    var th_ = this;
    
    this.phaser;
    
    this.particles = [];
    
    this.speedPow = 600;
    
    this.alphaTween;
    this.alphaTween_2;
    this.rotationTween;
    this.speedTween;
    
    this.initCall = function(){ };
    
    this.createCall = function(){
        
        //Randomize the number of points
        var nPoints = Phaser.Math.Between(8, 18);
        var pts = PolyCoords.Gen.circle(th_.startPos.x, th_.startPos.y, nPoints, 30, 90, 360, true);
        
        var imgName = "blue";
        
        var phaser = th_.phaser;
        
        for(var i = 0; i < pts.length; i++){
            
            var particle = new VisualEffects.Particle();
            
            particle.sprite = phaser.add.sprite(pts[i].x, pts[i].y, imgName);
            
            var pt = rotateCoords(th_.speedPow, 0, pts[i].rad);
            particle.velocity.x = pt[0];
            particle.velocity.y = pt[1];
            
            particle.sprite.setBlendMode('ADD');
            
            th_.particles.push(particle);
            
        }
        
        th_.alphaTween = phaser.tweens.addCounter({
            from: 0,
            to: 1,
            ease: 'Linear',
            duration: 50,
            yoyo: true,
            repeat: -1
        });
        th_.tweens.push(th_.alphaTween);
        
        th_.alphaTween_2 = phaser.tweens.addCounter({
            from: 1,
            to: 0,
            ease: 'Linear',
            duration: 1300,
            yoyo: false,
            repeat: 0
        });
        th_.tweens.push(th_.alphaTween_2);
        
        th_.rotationTween = phaser.tweens.addCounter({
            from: 0,
            to: 360,
            ease: 'Linear',
            duration: 2000,
            yoyo: true,
            repeat: 6
        });
        th_.tweens.push(th_.rotationTween);
        
        th_.speedTween = phaser.tweens.addCounter({
            from: 0,
            to: 1,
            ease: 'Linear',
            duration: 2000,
            yoyo: true,
            repeat: 6
        });
        th_.tweens.push(th_.speedTween);
        
    }
    
    
    this.destroyCall = function(){
        
        for(var i = 0; i < th_.particles.length; i++){
            th_.particles[i].sprite.destroy();
        }
        
    }
    
    
    
    this.updateCall = function(delta){
        
        var step = delta * 0.001;
        
        var alpha_1 = th_.alphaTween.getValue();
        var alpha_2 = th_.alphaTween_2.getValue();

        var alpha = alpha_1 * alpha_2;

        var rotation = th_.rotationTween.getValue();

        var speed = th_.speedTween.getValue();

        var fstep = step * speed;

        for(var i = 0; i < th_.particles.length; i++){

            var progress = th_.life / th_.lifeSpan;

            th_.particles[i].sprite.x += th_.particles[i].velocity.x * step;
            th_.particles[i].sprite.y += th_.particles[i].velocity.y * step;

            //th_.particles[i].sprite.y += 900 * step;

            th_.particles[i].sprite.setAlpha(alpha);

            //th_.particles[i].sprite.setAngle(rotation); 

        }
            
    }
    
}
VisualEffects.Fx1.prototype = Object.create(VisualEffects.Particles.prototype);
VisualEffects.Fx1.prototype.constructor = VisualEffects.Particles;

VisualEffects.Fx1.create = function(phaser, x, y){
    var vfx = new VisualEffects.Fx1();
    vfx.play(phaser, x, y);
    return vfx;
}



VisualEffects.Fx2 = function(){
    VisualEffects.Particles.call(this);
    
    var th_ = this;
    
    this.phaser;
    
    this.particles = [];
    
    this.speedPow = 600;
    
    this.alphaTween;
    this.alphaTween_2;
    this.rotationTween;
    this.speedTween;
    
    this.initCall = function(){ };
    
    this.createCall = function(){
        
        //Randomize the number of points
        var nPoints = Phaser.Math.Between(8, 16);
        var pts = PolyCoords.Gen.circle(th_.startPos.x, th_.startPos.y, nPoints, 30, 90, 360, true);
        
        var imgName = "red";
        
        var phaser = th_.phaser;
        
        for(var i = 0; i < pts.length; i++){
            
            var particle = new VisualEffects.Particle();
            
            particle.sprite = phaser.add.sprite(pts[i].x, pts[i].y, imgName);
            
            var pt = rotateCoords(th_.speedPow, 0, pts[i].rad);
            particle.velocity.x = pt[0];
            particle.velocity.y = pt[1];
            
            particle.sprite.setBlendMode('ADD');
            
            th_.particles.push(particle);
            
        }
        
        th_.alphaTween = phaser.tweens.addCounter({
            from: 0,
            to: 1,
            ease: 'Linear',
            duration: 50,
            yoyo: true,
            repeat: -1
        });
        th_.tweens.push(th_.alphaTween);
        
        th_.alphaTween_2 = phaser.tweens.addCounter({
            from: 1,
            to: 0,
            ease: 'Linear',
            duration: 1300,
            yoyo: false,
            repeat: 0
        });
        th_.tweens.push(th_.alphaTween_2);
        
        th_.rotationTween = phaser.tweens.addCounter({
            from: 0,
            to: 360,
            ease: 'Linear',
            duration: 2000,
            yoyo: true,
            repeat: 6
        });
        th_.tweens.push(th_.rotationTween);
        
        th_.speedTween = phaser.tweens.addCounter({
            from: 0,
            to: 1,
            ease: 'Linear',
            duration: 2000,
            yoyo: true,
            repeat: 6
        });
        th_.tweens.push(th_.speedTween);
        
    }
    
    
    this.destroyCall = function(){
        
        for(var i = 0; i < th_.particles.length; i++){
            th_.particles[i].sprite.destroy();
        }
        
    }
    
    
    
    this.updateCall = function(delta){
        
        var step = delta * 0.001;
        
        var alpha_1 = th_.alphaTween.getValue();
        var alpha_2 = th_.alphaTween_2.getValue();

        var alpha = alpha_1 * alpha_2;

        var rotation = th_.rotationTween.getValue();

        var speed = th_.speedTween.getValue();

        var fstep = step * speed;

        for(var i = 0; i < th_.particles.length; i++){

            var progress = th_.life / th_.lifeSpan;

            th_.particles[i].sprite.x += th_.particles[i].velocity.x * step;
            th_.particles[i].sprite.y += th_.particles[i].velocity.y * step;

            //th_.particles[i].sprite.y += 900 * step;

            th_.particles[i].sprite.setAlpha(alpha);

            //th_.particles[i].sprite.setAngle(rotation); 

        }
            
    }
    
}
VisualEffects.Fx2.prototype = Object.create(VisualEffects.Particles.prototype);
VisualEffects.Fx2.prototype.constructor = VisualEffects.Particles;

VisualEffects.Fx2.create = function(phaser, x, y){
    var vfx = new VisualEffects.Fx2();
    vfx.play(phaser, x, y);
    return vfx;
}




VisualEffects.Fx3 = function(){
    VisualEffects.Particles.call(this);
    
    var th_ = this;
    
    this.phaser;
    
    this.particles = [];
    
    this.speedPow = 600;
    
    this.alphaTween;
    this.alphaTween_2;
    this.rotationTween;
    this.speedTween;
    
    this.initCall = function(){ };
    
    this.createCall = function(){
        
        //Randomize the number of points
        var nPoints = Phaser.Math.Between(8, 16);
        var pts = PolyCoords.Gen.circle(th_.startPos.x, th_.startPos.y, nPoints, 30, 90, 360, true);
        
        var imgName = "green";
        
        var phaser = th_.phaser;
        
        for(var i = 0; i < pts.length; i++){
            
            var particle = new VisualEffects.Particle();
            
            particle.sprite = phaser.add.sprite(pts[i].x, pts[i].y, imgName);
            
            var pt = rotateCoords(th_.speedPow, 0, pts[i].rad);
            particle.velocity.x = pt[0];
            particle.velocity.y = pt[1];
            
            particle.sprite.setBlendMode('ADD');
            
            th_.particles.push(particle);
            
        }
        
        th_.alphaTween = phaser.tweens.addCounter({
            from: 0,
            to: 1,
            ease: 'Linear',
            duration: 50,
            yoyo: true,
            repeat: -1
        });
        th_.tweens.push(th_.alphaTween);
        
        th_.alphaTween_2 = phaser.tweens.addCounter({
            from: 1,
            to: 0,
            ease: 'Linear',
            duration: 1300,
            yoyo: false,
            repeat: 0
        });
        th_.tweens.push(th_.alphaTween_2);
        
        th_.rotationTween = phaser.tweens.addCounter({
            from: 0,
            to: 360,
            ease: 'Linear',
            duration: 2000,
            yoyo: true,
            repeat: 6
        });
        th_.tweens.push(th_.rotationTween);
        
        th_.speedTween = phaser.tweens.addCounter({
            from: 0,
            to: 1,
            ease: 'Linear',
            duration: 2000,
            yoyo: true,
            repeat: 6
        });
        th_.tweens.push(th_.speedTween);
        
    }
    
    
    this.destroyCall = function(){
        
        for(var i = 0; i < th_.particles.length; i++){
            th_.particles[i].sprite.destroy();
        }
        
    }
    
    
    
    this.updateCall = function(delta){
        
        var step = delta * 0.001;
        
        var alpha_1 = th_.alphaTween.getValue();
        var alpha_2 = th_.alphaTween_2.getValue();

        var alpha = alpha_1 * alpha_2;

        var rotation = th_.rotationTween.getValue();

        var speed = th_.speedTween.getValue();

        var fstep = step * speed;

        for(var i = 0; i < th_.particles.length; i++){

            var progress = th_.life / th_.lifeSpan;

            th_.particles[i].sprite.x += th_.particles[i].velocity.x * step;
            th_.particles[i].sprite.y += th_.particles[i].velocity.y * step;

            //th_.particles[i].sprite.y += 900 * step;

            th_.particles[i].sprite.setAlpha(alpha);

            //th_.particles[i].sprite.setAngle(rotation); 

        }
            
    }
    
}
VisualEffects.Fx3.prototype = Object.create(VisualEffects.Particles.prototype);
VisualEffects.Fx3.prototype.constructor = VisualEffects.Particles;

VisualEffects.Fx3.create = function(phaser, x, y){
    var vfx = new VisualEffects.Fx3();
    vfx.play(phaser, x, y);
    return vfx;
}



VisualEffects.Manager = function(phaser){
    
    var th_ = this;
    
    this.vfxs = [];
    this.dead;
    
    this.play = function(vfx_o, x, y){
        
        var vfx = vfx_o.create(phaser, x, y);
        
        th_.vfxs.push(vfx);
        
    }
    
    this.update = function(delta){
        
        var length = th_.vfxs.length;
        
        for(var i = 0; i < length; i++){
            
            var vfx = th_.vfxs[i];
            
            if(vfx.life > 0){
                
                vfx.update(delta);
                
            }
            else{
                
                //  Moves the dead particle to the end of the particles array (ready for splicing out later)
                var last = th_.vfxs[length - 1];

                th_.vfxs[length - 1] = vfx;
                th_.vfxs[i] = last;
                
                i -= 1;
                length -= 1;
                
            }
            
        }
        
        //  Move dead particles to the dead array
        var deadLength = th_.vfxs.length - length;
        
        if (deadLength > 0){
            
            var rip = th_.vfxs.splice(th_.vfxs.length - deadLength, deadLength);

            for (var i = 0; i < rip.length; i++){
                
                rip[i].destroy();
                
                
            }

            
        }
        
    }
    
}